OpenMM

- Main Page
- Related Pages
- Classes

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
Classes | Public Member Functions | Protected Member Functions | List of all members
HarmonicAngleForce Class Reference

This class implements an interaction between groups of three particles that varies harmonically with the angle between them. More...

`#include <HarmonicAngleForce.h>`

Inheritance diagram for HarmonicAngleForce:

## Public Member Functions
| HarmonicAngleForce ()
| Create a HarmonicAngleForce. More...
int | getNumAngles () const
| Get the number of harmonic bond angle terms in the potential function. More...
int | addAngle (int particle1, int particle2, int particle3, double angle, double k)
| Add an angle term to the force field. More...
void | getAngleParameters (int index, int &particle1, int &particle2, int &particle3, double &angle, double &k) const
| Get the force field parameters for an angle term. More...
void | setAngleParameters (int index, int particle1, int particle2, int particle3, double angle, double k)
| Set the force field parameters for an angle term. More...
void | updateParametersInContext (Context &context)
| Update the per-angle parameters in a Context to match those stored in this Force object. More...
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions
ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Detailed Description

This class implements an interaction between groups of three particles that varies harmonically with the angle between them.

To use it, create a HarmonicAngleForce object then call addAngle() once for each angle. After an angle has been added, you can modify its force field parameters by calling setAngleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

HarmonicAngleForce | ( |  | ) |

Create a HarmonicAngleForce.

## Member Function Documentation

int addAngle | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | double | angle,
|  | double | k
| ) |  |

Add an angle term to the force field.

Parameters

  particle1 | the index of the first particle forming the angle
  particle2 | the index of the second particle forming the angle
  particle3 | the index of the third particle forming the angle
  angle | the equilibrium angle, measured in radians
  k | the harmonic force constant for the angle, measured in kJ/mol/radian^2

Returns
  the index of the angle that was added

ForceImpl* createImpl | ( |  | ) | const
| protected virtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

void getAngleParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | double & | angle,
|  | double & | k
| ) |  | const

Get the force field parameters for an angle term.

Parameters

  index | the index of the angle for which to get parameters
  particle1 | the index of the first particle forming the angle
  particle2 | the index of the second particle forming the angle
  particle3 | the index of the third particle forming the angle
  angle | the equilibrium angle, measured in radians
  k | the harmonic force constant for the angle, measured in kJ/mol/radian^2

int getNumAngles | ( |  | ) | const
| inline

Get the number of harmonic bond angle terms in the potential function.

void setAngleParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | double | angle,
|  | double | k
| ) |  |

Set the force field parameters for an angle term.

Parameters

  index | the index of the angle for which to set parameters
  particle1 | the index of the first particle forming the angle
  particle2 | the index of the second particle forming the angle
  particle3 | the index of the third particle forming the angle
  angle | the equilibrium angle, measured in radians
  k | the harmonic force constant for the angle, measured in kJ/mol/radian^2

void updateParametersInContext | ( | Context & | context | ) |

Update the per-angle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setAngleParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

The only information this method updates is the values of per-angle parameters. The set of particles involved in a angle cannot be changed, nor can new angles be added.

bool usesPeriodicBoundaryConditions | ( |  | ) | const
| inline virtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  true if force uses PBC and false otherwise

Reimplemented from Force.

The documentation for this class was generated from the following file:

- HarmonicAngleForce.h